<!doctype html>
<html>
<head>
    <title>New Release: Tor 0.3.4.8 (also other stable updates: 0.2.9.17, 0.3.2.12, and 0.3.3.10) | The Tor Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="monetization" content="$ilp.uphold.com/pYfXb92JBQN4">
    <link rel="stylesheet" href="../static/css/style.css?h=5fc6c25a">
    <link rel="stylesheet" href="../static/fonts/fontawesome/css/all.min.css?h=9d272f6a">
    <link rel="stylesheet" href="../static/pygments.css">
    <link rel="icon" type="image/x-icon" href="../static/images/favicon/favicon.ico">
    <link rel="icon" type="image/png" href="../static/images/favicon/favicon.png">
    <meta property="og:title" content="New Release: Tor 0.3.4.8 (also other stable updates: 0.2.9.17, 0.3.2.12, and 0.3.3.10) | Tor Project">
    <meta property="og:description" content="After months of work, we have a new stable release series! If you build Tor from source, you can download the source code for 0.3.4.8 on the download page of the website. Packages should be available within the next several weeks, with a new Tor Browser by some time next week.">
    <meta property="og:image" content="https://blog.torproject.org/new-release-tor-0348-also-other-stable-updates-02917-03212-and-03310/lead.png">
    <meta property="og:url" content="https://blog.torproject.org/new-release-tor-0348-also-other-stable-updates-02917-03212-and-03310/">
    <meta name="twitter:card" content="summary_large_image">
</head>
<body>
  <header>
    <nav>
      <a class="navbar-brand" href="../"><img alt="Tor Blog" src="../static/images/logo.png" /></a>
      <ul class="navbar-nav">
          <li><a href="https://www.torproject.org/about/history/">About</a></li>
          <li><a href="https://support.torproject.org/">Support</a></li>
          <li><a href="https://community.torproject.org/">Community</a></li>
          <li><a href="https://forum.torproject.org/">Forum</a></li>
          <li><a href="https://donate.torproject.org/">Donate</a></li></ul>
    </nav>
  </header>
  <section class="content">
    <main>
  <article class="blog-post">
      <h1 class="title">
        New Release: Tor 0.3.4.8 (also other stable updates: 0.2.9.17, 0.3.2.12, and 0.3.3.10)
      </h1>
    <p class="meta">by nickm | September 10, 2018</p>
    <picture>
      
      <img class="lead" src="lead.png">
    </picture>
    <div class="body">
      <link rel="stylesheet" href="../static/css/legacy.css?h=21ddbb2d">
      <p>After months of work, we have a new stable release series! If you build Tor from source, you can download the source code for 0.3.4.8 on the download page of the website. Packages should be available within the next several weeks, with a new Tor Browser by some time next week.</p>
<p>Additionally, we're also releasing updates today for the older supported release series: 0.2.9.17, 0.3.2.12, and 0.3.3.10 .  You can find them at <a href="https://dist.torproject.org/">dist.torproject.org</a>.</p>
<p>Tor 0.3.4.8 is the first stable release in its series; it includes compilation and portability fixes.</p>
<p>The Tor 0.3.4 series includes improvements for running Tor in low-power and embedded environments, which should help performance in general. We've begun work on better modularity, and included preliminary changes on the directory authority side to accommodate a new bandwidth measurement system. We've also integrated more continuous-integration systems into our development process, and made corresponding changes to Tor's testing infrastructure. Finally, we've continued to refine our anti-denial-of-service code.</p>
<p>Below are the changes since 0.3.3.9. For a list of only the changes since 0.3.4.7-rc, see the ChangeLog file.</p>
<h2>Changes in version 0.3.4.8 - 2018-09-10</h2>
<ul>
<li>New system requirements:
<ul>
<li>Tor no longer tries to support old operating systems without mmap() or some local equivalent. Apparently, compilation on such systems has been broken for some time, without anybody noticing or complaining. Closes ticket <a href="https://bugs.torproject.org/25398">25398</a>.</li>
</ul>
</li>
<li>Major features (directory authority, modularization):
<ul>
<li>The directory authority subsystem has been modularized. The code is now located in src/or/dirauth/, and is compiled in by default. To disable the module, the configure option --disable-module-dirauth has been added. This module may be disabled by default in some future release. Closes ticket <a href="https://bugs.torproject.org/25610">25610</a>.</li>
</ul>
</li>
</ul>
<p> </p>
<!--break--><ul>
<li>Major features (main loop, CPU usage):
<ul>
<li>When Tor is disabled (via DisableNetwork or via hibernation), it no longer needs to run any per-second events. This change should make it easier for mobile applications to disable Tor while the device is sleeping, or Tor is not running. Closes ticket <a href="https://bugs.torproject.org/26063">26063</a>.</li>
<li>Tor no longer enables all of its periodic events by default. Previously, Tor would enable all possible main loop events, regardless of whether it needed them. Furthermore, many of these events are now disabled when Tor is hibernating or DisableNetwork is set. This is a big step towards reducing client CPU usage by reducing the amount of wake-ups the daemon does. Closes tickets 25376 and 25762.</li>
<li>The bandwidth-limitation logic has been refactored so that bandwidth calculations are performed on-demand, rather than every TokenBucketRefillInterval milliseconds. This change should improve the granularity of our bandwidth calculations, and limit the number of times that the Tor process needs to wake up when it is idle. Closes ticket <a href="https://bugs.torproject.org/25373">25373</a>.</li>
<li>Move responsibility for many operations from a once-per-second callback to a callback that is only scheduled as needed. Moving this functionality has allowed us to disable the callback when Tor's network is disabled. Once enough items are removed from our once-per-second callback, we can eliminate it entirely to conserve CPU when idle. The functionality removed includes: closing connections, circuits, and channels (ticket <a href="https://bugs.torproject.org/25932">25932</a>); consensus voting (25937); flushing log callbacks (25951); honoring delayed SIGNEWNYM requests (25949); rescanning the consensus cache (25931); saving the state file to disk (25948); warning relay operators about unreachable ports (25952); and keeping track of Tor's uptime (26009).</li>
</ul>
</li>
<li>Minor features (accounting):
<ul>
<li>When Tor becomes dormant, it now uses a scheduled event to wake up at the right time. Previously, we would use the per-second timer to check whether to wake up, but we no longer have any per-second timers enabled when the network is disabled. Closes ticket <a href="https://bugs.torproject.org/26064">26064</a>.</li>
</ul>
</li>
<li>Minor features (bug workaround):
<ul>
<li>Compile correctly on systems that provide the C11 stdatomic.h header, but where C11 atomic functions don't actually compile. Closes ticket <a href="https://bugs.torproject.org/26779">26779</a>; workaround for Debian issue 903709.</li>
</ul>
</li>
<li>Minor features (code quality):
<ul>
<li>Add optional spell-checking for the Tor codebase, using the "misspell" program. To use this feature, run "make check-typos". Closes ticket <a href="https://bugs.torproject.org/25024">25024</a>.</li>
</ul>
</li>
<li>Minor features (compatibility):
<ul>
<li>Tell OpenSSL to maintain backward compatibility with previous RSA1024/DH1024 users in Tor. With OpenSSL 1.1.1-pre6, these ciphers are disabled by default. Closes ticket <a href="https://bugs.torproject.org/27344">27344</a>.</li>
<li>Tor now detects versions of OpenSSL 1.1.0 and later compiled with the no-deprecated option, and builds correctly with them. Closes tickets 19429, 19981, and 25353.</li>
</ul>
</li>
<li>Minor features (compilation):
<ul>
<li>When compiling with --enable-openbsd-malloc or --enable-tcmalloc, tell the compiler not to include the system malloc implementation. Fixes bug <a href="https://bugs.torproject.org/20424">20424</a>; bugfix on 0.2.0.20-rc.</li>
<li>Don't try to use a pragma to temporarily disable the -Wunused-const-variable warning if the compiler doesn't support it. Fixes bug <a href="https://bugs.torproject.org/26785">26785</a>; bugfix on 0.3.2.11.</li>
<li>When building Tor, prefer to use Python 3 over Python 2, and more recent (contemplated) versions over older ones. Closes ticket <a href="https://bugs.torproject.org/26372">26372</a>.</li>
</ul>
</li>
<li>Minor features (compression, zstd):
<ul>
<li>When running with zstd, Tor now considers using advanced functions that the zstd maintainers have labeled as potentially unstable. To prevent breakage, Tor will only use this functionality when the runtime version of the zstd library matches the version with which Tor was compiled. Closes ticket <a href="https://bugs.torproject.org/25162">25162</a>.</li>
</ul>
</li>
<li>Minor features (configuration):
<ul>
<li>The "DownloadSchedule" options have been renamed to end with "DownloadInitialDelay". The old names are still allowed, but will produce a warning. Comma-separated lists are still permitted for these options, but all values after the first are ignored (as they have been since 0.2.9). Closes ticket <a href="https://bugs.torproject.org/23354">23354</a>.</li>
</ul>
</li>
<li>Minor features (continuous integration):
<ul>
<li>Log the compiler path and version during Appveyor builds. Implements ticket <a href="https://bugs.torproject.org/27449">27449</a>.</li>
<li>Show config.log and test-suite.log after failed Appveyor builds. Also upload the zipped full logs as a build artifact. Implements ticket <a href="https://bugs.torproject.org/27430">27430</a>.</li>
<li>Backport Travis rust distcheck to 0.3.3. Closes ticket <a href="https://bugs.torproject.org/24629">24629</a>.</li>
<li>Enable macOS builds in our Travis CI configuration. Closes ticket <a href="https://bugs.torproject.org/24629">24629</a>.</li>
<li>Install libcap-dev and libseccomp2-dev so these optional dependencies get tested on Travis CI. Closes ticket <a href="https://bugs.torproject.org/26560">26560</a>.</li>
<li>Only post Appveyor IRC notifications when the build fails. Implements ticket <a href="https://bugs.torproject.org/27275">27275</a>.</li>
<li>Run asciidoc during Travis CI. Implements ticket <a href="https://bugs.torproject.org/27087">27087</a>.</li>
<li>Use ccache in our Travis CI configuration. Closes ticket <a href="https://bugs.torproject.org/26952">26952</a>.</li>
<li>Add the necessary configuration files for continuous integration testing on Windows, via the Appveyor platform. Closes ticket <a href="https://bugs.torproject.org/25549">25549</a>. Patches from Marcin Cieślak and Isis Lovecruft.</li>
</ul>
</li>
<li>Minor features (continuous integration, rust):
<ul>
<li>Use cargo cache in our Travis CI configuration. Closes ticket <a href="https://bugs.torproject.org/26952">26952</a>.</li>
</ul>
</li>
<li>Minor features (control port):
<ul>
<li>Introduce GETINFO "current-time/{local,utc}" to return the local and UTC times respectively in ISO format. This helps a controller like Tor Browser detect a time-related error. Closes ticket <a href="https://bugs.torproject.org/25511">25511</a>. Patch by Neel Chauhan.</li>
<li>Introduce new fields to the CIRC_BW event. There are two new fields in each of the read and written directions. The DELIVERED fields report the total valid data on the circuit, as measured by the payload sizes of verified and error-checked relay command cells. The OVERHEAD fields report the total unused bytes in each of these cells. Closes ticket <a href="https://bugs.torproject.org/25903">25903</a>.</li>
</ul>
</li>
<li>Minor features (controller):
<ul>
<li>The control port now exposes the list of HTTPTunnelPorts and ExtOrPorts via GETINFO net/listeners/httptunnel and net/listeners/extor respectively. Closes ticket <a href="https://bugs.torproject.org/26647">26647</a>.</li>
</ul>
</li>
<li>Minor features (directory authorities):
<ul>
<li>Stop warning about incomplete bw lines before the first complete bw line has been found, so that additional header lines can be ignored. Fixes bug <a href="https://bugs.torproject.org/25960">25960</a>; bugfix on 0.2.2.1-alpha</li>
<li>Authorities no longer vote to make the subprotocol version "LinkAuth=1" a requirement: it is unsupportable with NSS, and hasn't been needed since Tor 0.3.0.1-alpha. Closes ticket <a href="https://bugs.torproject.org/27286">27286</a>.</li>
</ul>
</li>
<li>Minor features (directory authority):
<ul>
<li>Directory authorities now open their key-pinning files as O_SYNC, to limit their chances of accidentally writing partial lines. Closes ticket <a href="https://bugs.torproject.org/23909">23909</a>.</li>
</ul>
</li>
<li>Minor features (directory authority, forward compatibility):
<ul>
<li>Make the lines of the measured bandwidth file able to contain their entries in any order. Previously, the node_id entry needed to come first. Closes ticket <a href="https://bugs.torproject.org/26004">26004</a>.</li>
</ul>
</li>
<li>Minor features (entry guards):
<ul>
<li>Introduce a new torrc option NumPrimaryGuards for controlling the number of primary guards. Closes ticket <a href="https://bugs.torproject.org/25843">25843</a>.</li>
</ul>
</li>
<li>Minor features (geoip):
<ul>
<li>Update geoip and geoip6 to the August 7 2018 Maxmind GeoLite2 Country database. Closes ticket <a href="https://bugs.torproject.org/27089">27089</a>.</li>
</ul>
</li>
<li>Minor features (performance):
<ul>
<li>Avoid a needless call to malloc() when processing an incoming relay cell. Closes ticket <a href="https://bugs.torproject.org/24914">24914</a>.</li>
<li>Make our timing-wheel code run a tiny bit faster on 32-bit platforms, by preferring 32-bit math to 64-bit. Closes ticket <a href="https://bugs.torproject.org/24688">24688</a>.</li>
<li>Avoid a needless malloc()/free() pair every time we handle an ntor handshake. Closes ticket <a href="https://bugs.torproject.org/25150">25150</a>.</li>
</ul>
</li>
<li>Minor features (Rust, portability):
<ul>
<li>Rust cross-compilation is now supported. Closes ticket <a href="https://bugs.torproject.org/25895">25895</a>.</li>
</ul>
</li>
<li>Minor features (testing):
<ul>
<li>Add a unit test for voting_schedule_get_start_of_next_interval(). Closes ticket <a href="https://bugs.torproject.org/26014">26014</a>, and helps make unit test coverage more deterministic.</li>
<li>A new unittests module specifically for testing the functions in the (new-ish) bridges.c module has been created with new unittests, raising the code coverage percentages. Closes 25425.</li>
<li>We now have improved testing for addressmap_get_virtual_address() function. This should improve our test coverage, and make our test coverage more deterministic. Closes ticket <a href="https://bugs.torproject.org/25993">25993</a>.</li>
</ul>
</li>
<li>Minor features (timekeeping, circuit scheduling):
<ul>
<li>When keeping track of how busy each circuit have been recently on a given connection, use coarse-grained monotonic timers rather than gettimeofday(). This change should marginally increase accuracy and performance. Implements part of ticket <a href="https://bugs.torproject.org/25927">25927</a>.</li>
</ul>
</li>
<li>Minor features (unit tests):
<ul>
<li>Test complete bandwidth measurements files, and test that incomplete bandwidth lines only give warnings when the end of the header has not been detected. Fixes bug <a href="https://bugs.torproject.org/25947">25947</a>; bugfix on 0.2.2.1-alpha</li>
</ul>
</li>
<li>Minor bugfixes (bandwidth management):
<ul>
<li>Consider ourselves "low on write bandwidth" if we have exhausted our write bandwidth some time in the last second. This was the documented behavior before, but the actual behavior was to change this value every TokenBucketRefillInterval. Fixes bug <a href="https://bugs.torproject.org/25828">25828</a>; bugfix on 0.2.3.5-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (C correctness):
<ul>
<li>Add a missing lock acquisition in the shutdown code of the control subsystem. Fixes bug <a href="https://bugs.torproject.org/25675">25675</a>; bugfix on 0.2.7.3-rc. Found by Coverity; this is CID 1433643.</li>
</ul>
</li>
<li>Minor bugfixes (code style):
<ul>
<li>Fixed multiple includes of transports.h in src/or/connection.c Fixes bug <a href="https://bugs.torproject.org/25261">25261</a>; bugfix on 0.2.5.1-alpha.</li>
<li>Remove the unused variable n_possible from the function channel_get_for_extend(). Fixes bug <a href="https://bugs.torproject.org/25645">25645</a>; bugfix on 0.2.4.4-alpha</li>
</ul>
</li>
<li>Minor bugfixes (compilation):
<ul>
<li>Silence a spurious compiler warning on the GetAdaptersAddresses function pointer cast. This issue is already fixed by 26481 in 0.3.5 and later, by removing the lookup and cast. Fixes bug <a href="https://bugs.torproject.org/27465">27465</a>; bugfix on 0.2.3.11-alpha.</li>
<li>Stop calling SetProcessDEPPolicy() on 64-bit Windows. It is not supported, and always fails. Some compilers warn about the function pointer cast on 64-bit Windows. Fixes bug <a href="https://bugs.torproject.org/27461">27461</a>; bugfix on 0.2.2.23-alpha.</li>
<li>Fix a compilation warning on some versions of GCC when building code that calls routerinfo_get_my_routerinfo() twice, assuming that the second call will succeed if the first one did. Fixes bug <a href="https://bugs.torproject.org/26269">26269</a>; bugfix on 0.2.8.2-alpha.</li>
<li>Refrain from compiling unit testing related object files when --disable-unittests is set to configure script. Fixes bug <a href="https://bugs.torproject.org/24891">24891</a>; bugfix on 0.2.5.1-alpha.</li>
<li>The --enable-fatal-warnings flag now affects Rust code as well. Closes ticket <a href="https://bugs.torproject.org/26245">26245</a>.</li>
<li>Avoid a compiler warning when casting the return value of smartlist_len() to double with DEBUG_SMARTLIST enabled. Fixes bug <a href="https://bugs.torproject.org/26283">26283</a>; bugfix on 0.2.4.10-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (compilation, windows):
<ul>
<li>Don't link or search for pthreads when building for Windows, even if we are using build environment (like mingw) that provides a pthreads library. Fixes bug <a href="https://bugs.torproject.org/27081">27081</a>; bugfix on 0.1.0.1-rc.</li>
</ul>
</li>
<li>Minor bugfixes (continuous integration):
<ul>
<li>Build with zstd on macOS. Fixes bug <a href="https://bugs.torproject.org/27090">27090</a>; bugfix on 0.3.1.5-alpha.</li>
<li>Skip a pair of unreliable key generation tests on Windows, until the underlying issue in bug <a href="https://bugs.torproject.org/26076">26076</a> is resolved. Fixes bug <a href="https://bugs.torproject.org/26830">26830</a> and bug <a href="https://bugs.torproject.org/26853">26853</a>; bugfix on 0.2.7.3-rc and 0.3.2.1-alpha respectively.</li>
</ul>
</li>
<li>Minor bugfixes (control port):
<ul>
<li>Respond with more human-readable error messages to GETINFO exit- policy/* requests. Also, let controller know if an error is transient (response code 551) or not (response code 552). Fixes bug <a href="https://bugs.torproject.org/25852">25852</a>; bugfix on 0.2.8.1-alpha.</li>
<li>Parse the "HSADDRESS=" parameter in HSPOST commands properly. Previously, it was misparsed and ignored. Fixes bug <a href="https://bugs.torproject.org/26523">26523</a>; bugfix on 0.3.3.1-alpha. Patch by "akwizgran".</li>
<li>Make CIRC_BW event reflect the total of all data sent on a circuit, including padding and dropped cells. Also fix a mis- counting bug when STREAM_BW events were enabled. Fixes bug <a href="https://bugs.torproject.org/25400">25400</a>; bugfix on 0.2.5.2-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (correctness, flow control):
<ul>
<li>Upon receiving a stream-level SENDME cell, verify that our window has not grown too large. Fixes bug <a href="https://bugs.torproject.org/26214">26214</a>; bugfix on svn r54 (pre-0.0.1)</li>
</ul>
</li>
<li>Minor bugfixes (directory authority):
<ul>
<li>When voting for recommended versions, make sure that all of the versions are well-formed and parsable. Fixes bug <a href="https://bugs.torproject.org/26485">26485</a>; bugfix on 0.1.1.6-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (directory client):
<ul>
<li>When unverified-consensus is verified, rename it to cached- consenus. Fixes bug <a href="https://bugs.torproject.org/4187">4187</a>; bugfix on 0.2.0.3-alpha.</li>
<li>Fixed launching a certificate fetch always during the scheduled periodic consensus fetch by fetching only in those cases when consensus are waiting for certs. Fixes bug <a href="https://bugs.torproject.org/24740">24740</a>; bugfix on 0.2.9.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (error reporting):
<ul>
<li>Improve tolerance for directory authorities with skewed clocks. Previously, an authority with a clock more than 60 seconds ahead could cause a client with a correct clock to warn that the client's clock was behind. Now the clocks of a majority of directory authorities have to be ahead of the client before this warning will occur. Fixes bug <a href="https://bugs.torproject.org/25756">25756</a>; bugfix on 0.2.2.25-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (in-process restart):
<ul>
<li>Always call tor_free_all() when leaving tor_run_main(). When we did not, restarting tor in-process would cause an assertion failure. Fixes bug <a href="https://bugs.torproject.org/26948">26948</a>; bugfix on 0.3.3.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (Linux seccomp2 sandbox):
<ul>
<li>Fix a bug in our sandboxing rules for the openat() syscall. Previously, no openat() call would be permitted, which would break filesystem operations on recent glibc versions. Fixes bug <a href="https://bugs.torproject.org/25440">25440</a>; bugfix on 0.2.9.15. Diagnosis and patch from Daniel Pinto.</li>
</ul>
</li>
<li>Minor bugfixes (logging):
<ul>
<li>Improve the log message when connection initiators fail to authenticate direct connections to relays. Fixes bug <a href="https://bugs.torproject.org/26927">26927</a>; bugfix on 0.3.0.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (onion services):
<ul>
<li>Silence a spurious compiler warning in rend_client_send_introduction(). Fixes bug <a href="https://bugs.torproject.org/27463">27463</a>; bugfix on 0.1.1.2-alpha.</li>
<li>Fix bug that causes services to not ever rotate their descriptors if they were getting SIGHUPed often. Fixes bug <a href="https://bugs.torproject.org/26932">26932</a>; bugfix on 0.3.2.1-alpha.</li>
<li>Recompute some consensus information after detecting a clock jump, or after transitioning from a non-live consensus to a live consensus. We do this to avoid having an outdated state, and miscalculating the index for next-generation onion services. Fixes bug <a href="https://bugs.torproject.org/24977">24977</a>; bugfix on 0.3.2.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (portability):
<ul>
<li>Fix compilation of the unit tests on GNU/Hurd, which does not define PATH_MAX. Fixes bug <a href="https://bugs.torproject.org/26873">26873</a>; bugfix on 0.3.3.1-alpha. Patch from "paulusASol".</li>
<li>Work around two different bugs in the OS X 10.10 and later SDKs that would prevent us from successfully targeting earlier versions of OS X. Fixes bug <a href="https://bugs.torproject.org/26876">26876</a>; bugfix on 0.3.3.1-alpha.</li>
<li>Do not align mmap length, as it is not required by POSIX, and the getpagesize function is deprecated. Fixes bug <a href="https://bugs.torproject.org/25399">25399</a>; bugfix on 0.1.1.23.</li>
</ul>
</li>
<li>Minor bugfixes (portability, FreeBSD):
<ul>
<li>In have_enough_mem_for_dircache(), the variable DIRCACHE_MIN_MEM_MB does not stringify on FreeBSD, so we switch to tor_asprintf(). Fixes bug <a href="https://bugs.torproject.org/20887">20887</a>; bugfix on 0.2.8.1-alpha. Patch by Neel Chauhan.</li>
</ul>
</li>
<li>Minor bugfixes (relay statistics):
<ul>
<li>When a relay is collecting internal statistics about how many create cell requests it has seen of each type, accurately count the requests from relays that temporarily fall out of the consensus. (To be extra conservative, we were already ignoring requests from clients in our counts, and we continue ignoring them here.) Fixes bug <a href="https://bugs.torproject.org/24910">24910</a>; bugfix on 0.2.4.17-rc.</li>
</ul>
</li>
<li>Minor bugfixes (rust):
<ul>
<li>Backport test_rust.sh from master. Fixes bug <a href="https://bugs.torproject.org/26497">26497</a>; bugfix on 0.3.1.5-alpha.</li>
<li>Protover parsing was accepting the presence of whitespace in version strings, which the C implementation would choke on, e.g. "Desc=1\t,2". Fixes bug <a href="https://bugs.torproject.org/27177">27177</a>; bugfix on 0.3.3.5-rc.</li>
<li>Protover parsing was ignoring a 2nd hyphen and everything after it, accepting entries like "Link=1-5-foo". Fixes bug <a href="https://bugs.torproject.org/27164">27164</a>; bugfix on 0.3.3.1-alpha.</li>
<li>Stop setting $CARGO_HOME. cargo will use the user's $CARGO_HOME, or $HOME/.cargo by default. Fixes bug <a href="https://bugs.torproject.org/26497">26497</a>; bugfix on 0.3.1.5-alpha.</li>
<li>cd to ${abs_top_builddir}/src/rust before running cargo in src/test/test_rust.sh. This makes the working directory consistent between builds and tests. Fixes bug <a href="https://bugs.torproject.org/26497">26497</a>; bugfix on 0.3.3.2-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (single onion services, Tor2web):
<ul>
<li>Log a protocol warning when single onion services or Tor2web clients fail to authenticate direct connections to relays. Fixes bug <a href="https://bugs.torproject.org/26924">26924</a>; bugfix on 0.2.9.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (test coverage tools):
<ul>
<li>Update our "cov-diff" script to handle output from the latest version of gcov, and to remove extraneous timestamp information from its output. Fixes bugs 26101 and 26102; bugfix on 0.2.5.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (testing):
<ul>
<li>Disable core dumps in test_bt.sh, to avoid failures in "make distcheck". Fixes bug <a href="https://bugs.torproject.org/26787">26787</a>; bugfix on 0.2.5.2-alpha.</li>
<li>When testing workqueue event-cancellation, make sure that we actually cancel an event, and that cancel each event with equal probability. (It was previously possible, though extremely unlikely, for our event-canceling test not to cancel any events.) Fixes bug <a href="https://bugs.torproject.org/26008">26008</a>; bugfix on 0.2.6.3-alpha.</li>
<li>Repeat part of the test in test_client_pick_intro() a number of times, to give it consistent coverage. Fixes bug <a href="https://bugs.torproject.org/25996">25996</a>; bugfix on 0.3.2.1-alpha.</li>
<li>Remove randomness from the hs_common/responsible_hsdirs test, so that it always takes the same path through the function it tests. Fixes bug <a href="https://bugs.torproject.org/25997">25997</a>; bugfix on 0.3.2.1-alpha.</li>
<li>Change the behavior of the "channel/outbound" test so that it never causes a 10-second rollover for the EWMA circuitmux code. Previously, this behavior would happen randomly, and result in fluctuating test coverage. Fixes bug <a href="https://bugs.torproject.org/25994">25994</a>; bugfix on 0.3.3.1-alpha.</li>
<li>Use X509_new() to allocate certificates that will be freed later with X509_free(). Previously, some parts of the unit tests had used tor_malloc_zero(), which is incorrect, and which caused test failures on Windows when they were built with extra hardening. Fixes bugs 25943 and 25944; bugfix on 0.2.8.1-alpha. Patch by Marcin Cieślak.</li>
<li>While running the circuit_timeout test, fix the PRNG to a deterministic AES stream, so that the test coverage from this test will itself be deterministic. Fixes bug <a href="https://bugs.torproject.org/25995">25995</a>; bugfix on 0.2.2.2-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (testing, bootstrap):
<ul>
<li>When calculating bootstrap progress, check exit policies and the exit flag. Previously, Tor would only check the exit flag, which caused race conditions in small and fast networks like chutney. Fixes bug <a href="https://bugs.torproject.org/27236">27236</a>; bugfix on 0.2.6.3-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (testing, chutney):
<ul>
<li>When running make test-network-all, use the mixed+hs-v2 network. (A previous fix to chutney removed v3 onion services from the mixed+hs-v23 network, so seeing "mixed+hs-v23" in tests is confusing.) Fixes bug <a href="https://bugs.torproject.org/27345">27345</a>; bugfix on 0.3.2.1-alpha.</li>
<li>Before running make test-network-all, delete old logs and test result files, to avoid spurious failures. Fixes bug <a href="https://bugs.torproject.org/27295">27295</a>; bugfix on 0.2.7.3-rc.</li>
</ul>
</li>
<li>Minor bugfixes (testing, openssl compatibility):
<ul>
<li>Our "tortls/cert_matches_key" unit test no longer relies on OpenSSL internals. Previously, it relied on unsupported OpenSSL behavior in a way that caused it to crash with OpenSSL 1.0.2p. Fixes bug <a href="https://bugs.torproject.org/27226">27226</a>; bugfix on 0.2.5.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (v3 onion services):
<ul>
<li>Stop sending ed25519 link specifiers in v3 onion service introduce cells and descriptors, when the rendezvous or introduction point doesn't support ed25519 link authentication. Fixes bug <a href="https://bugs.torproject.org/26627">26627</a>; bugfix on 0.3.2.4-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (vanguards):
<ul>
<li>Allow the last hop in a vanguard circuit to be the same as our first, to prevent the adversary from influencing guard node choice by choice of last hop. Also prevent the creation of A - B - A paths, or A - A paths, which are forbidden by relays. Fixes bug <a href="https://bugs.torproject.org/25870">25870</a>; bugfix on 0.3.3.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (Windows, compilation):
<ul>
<li>Silence a compilation warning on MSVC 2017 and clang-cl. Fixes bug <a href="https://bugs.torproject.org/27185">27185</a>; bugfix on 0.2.2.2-alpha.</li>
</ul>
</li>
<li>Code simplification and refactoring:
<ul>
<li>Remove duplicate code in parse_{c,s}method_line and bootstrap their functionalities into a single function. Fixes bug <a href="https://bugs.torproject.org/6236">6236</a>; bugfix on 0.2.3.6-alpha.</li>
<li>We remove the PortForwsrding and PortForwardingHelper options, related functions, and the port_forwarding tests. These options were used by the now-deprecated Vidalia to help ordinary users become Tor relays or bridges. Closes ticket <a href="https://bugs.torproject.org/25409">25409</a>. Patch by Neel Chauhan.</li>
<li>In order to make the OR and dir checking function in router.c less confusing we renamed some functions and consider_testing_reachability() has been split into router_should_check_reachability() and router_do_reachability_checks(). Also we improved the documentation in some functions. Closes ticket <a href="https://bugs.torproject.org/18918">18918</a>.</li>
<li>Initial work to isolate Libevent usage to a handful of modules in our codebase, to simplify our call structure, and so that we can more easily change event loops in the future if needed. Closes ticket <a href="https://bugs.torproject.org/23750">23750</a>.</li>
<li>Introduce a function to call getsockname() and return tor_addr_t, to save a little complexity throughout the codebase. Closes ticket <a href="https://bugs.torproject.org/18105">18105</a>.</li>
<li>Make hsdir_index in node_t a hsdir_index_t rather than a pointer as hsdir_index is always present. Also, we move hsdir_index_t into or.h. Closes ticket <a href="https://bugs.torproject.org/23094">23094</a>. Patch by Neel Chauhan.</li>
<li>Merge functions used for describing nodes and suppress the functions that do not allocate memory for the output buffer string. NODE_DESC_BUF_LEN constant and format_node_description() function cannot be used externally from router.c module anymore. Closes ticket <a href="https://bugs.torproject.org/25432">25432</a>. Patch by valentecaio.</li>
<li>Our main loop has been simplified so that all important operations happen inside events. Previously, some operations had to happen outside the event loop, to prevent infinite sequences of event activations. Closes ticket <a href="https://bugs.torproject.org/25374">25374</a>.</li>
<li>Put a SHA1 public key digest in hs_service_intro_point_t, and use it in register_intro_circ() and service_intro_point_new(). This prevents the digest from being re-calculated each time. Closes ticket <a href="https://bugs.torproject.org/23107">23107</a>. Patch by Neel Chauhan.</li>
<li>Refactor token-bucket implementations to use a common backend. Closes ticket <a href="https://bugs.torproject.org/25766">25766</a>.</li>
<li>Remove extern declaration of stats_n_seconds_working variable from main, protecting its accesses with get_uptime() and reset_uptime() functions. Closes ticket <a href="https://bugs.torproject.org/25081">25081</a>, patch by “valentecaio”.</li>
<li>Remove our previous logic for "cached gettimeofday()" -- our coarse monotonic timers are fast enough for this purpose, and far less error-prone. Implements part of ticket <a href="https://bugs.torproject.org/25927">25927</a>.</li>
<li>Remove the return value for fascist_firewall_choose_address_base(), and sister functions such as fascist_firewall_choose_address_node() and fascist_firewall_choose_address_rs(). Also, while we're here, initialize the ap argument as leaving it uninitialized can pose a security hazard. Closes ticket <a href="https://bugs.torproject.org/24734">24734</a>. Patch by Neel Chauhan.</li>
<li>Rename two fields of connection_t struct. timestamp_lastwritten is renamed to timestamp_last_write_allowed and timestamp_lastread is renamed to timestamp_last_read_allowed. Closes ticket <a href="https://bugs.torproject.org/24714">24714</a>, patch by "valentecaio".</li>
<li>Since Tor requires C99, remove our old workaround code for libc implementations where free(NULL) doesn't work. Closes ticket <a href="https://bugs.torproject.org/24484">24484</a>.</li>
<li>Use our standard rate-limiting code to deal with excessive libevent failures, rather than the hand-rolled logic we had before. Closes ticket <a href="https://bugs.torproject.org/26016">26016</a>.</li>
<li>We remove the return value of node_get_prim_orport() and node_get_prim_dirport(), and introduce node_get_prim_orport() in node_ipv6_or_preferred() and node_ipv6_dir_preferred() in order to check for a null address. Closes ticket <a href="https://bugs.torproject.org/23873">23873</a>. Patch by Neel Chauhan.</li>
<li>We switch to should_record_bridge_info() in geoip_note_client_seen() and options_need_geoip_info() instead of accessing the configuration values directly. Fixes bug <a href="https://bugs.torproject.org/25290">25290</a>; bugfix on 0.2.1.6-alpha. Patch by Neel Chauhan.</li>
</ul>
</li>
<li>Deprecated features:
<ul>
<li>As we are not recommending 0.2.5 anymore, we require relays that once had an ed25519 key associated with their RSA key to always have that key, instead of allowing them to drop back to a version that didn't support ed25519. This means they need to use a new RSA key if the want to downgrade to an older version of tor without ed25519. Closes ticket <a href="https://bugs.torproject.org/20522">20522</a>.</li>
</ul>
</li>
<li>Removed features:
<ul>
<li>Directory authorities will no longer support voting according to any consensus method before consensus method 25. This keeps authorities compatible with all authorities running 0.2.9.8 and later, and does not break any clients or relays. Implements ticket <a href="https://bugs.torproject.org/24378">24378</a> and proposal 290.</li>
<li>The PortForwarding and PortForwardingHelper features have been removed. The reasoning is, given that implementations of NAT traversal protocols within common consumer grade routers are frequently buggy, and that the target audience for a NAT punching feature is a perhaps less-technically-inclined relay operator, when the helper fails to setup traversal the problems are usually deep, ugly, and very router specific, making them horrendously impossible for technical support to reliable assist with, and thus resulting in frustration all around. Unfortunately, relay operators who would like to run relays behind NATs will need to become more familiar with the port forwarding configurations on their local router. Closes 25409.</li>
<li>The TestingEnableTbEmptyEvent option has been removed. It was used in testing simulations to measure how often connection buckets were emptied, in order to improve our scheduling, but it has not been actively used in years. Closes ticket <a href="https://bugs.torproject.org/25760">25760</a>.</li>
<li>The old "round-robin" circuit multiplexer (circuitmux) implementation has been removed, along with a fairly large set of code that existed to support it. It has not been the default circuitmux since we introduced the "EWMA" circuitmux in 0.2.4.x, but it still required an unreasonable amount of memory and CPU. Closes ticket <a href="https://bugs.torproject.org/25268">25268</a>.</li>
</ul>
</li>
</ul>

    </div>
  <div class="categories">
    <ul><li>
        <a href="../category/releases">
          releases
        </a>
      </li></ul>
  </div>
  <div class="comments">
      <h2>Comments</h2>
      <p>Please note that the comment area below has been archived.</p>
      <a id="comment-277158"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-277158" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">September 11, 2018</p>
    </div>
    <a href="#comment-277158">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-277158" class="permalink" rel="bookmark">Is it acceptable to update…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Is it acceptable to update the Tor package within Tails? I don't like waiting a month or more for updates.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-277205"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-277205" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>None (not verified)</span> said:</p>
      <p class="date-time">September 11, 2018</p>
    </div>
    <a href="#comment-277205">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-277205" class="permalink" rel="bookmark">Maybe fix the Torproject…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Maybe fix the Torproject signing key?  How to get the new key?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-277237"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-277237" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>anonymos  (not verified)</span> said:</p>
      <p class="date-time">September 12, 2018</p>
    </div>
    <a href="#comment-277237">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-277237" class="permalink" rel="bookmark">Dears Tor team, 
we can…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Dears Tor team, </p>
<p>we can accsess tor sites without tor browser </p>
<p>if you open onion site and some words like </p>
<p>onion.city, onion.cab, onion.pet, onion.to </p>
<p>so onion using proxy so how come tor are invisble and secure if you can access without browser :) so anyone can accsess it we need a new project invisble network and annoynmos so we can protect our self me be for Tor 9 it will be great.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-277247"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-277247" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">September 13, 2018</p>
    </div>
    <a href="#comment-277247">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-277247" class="permalink" rel="bookmark">Is it safe to update to this…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Is it safe to update to this via Tails?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-277267"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-277267" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">September 13, 2018</p>
    </div>
    <a href="#comment-277267">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-277267" class="permalink" rel="bookmark">OT, but privacy advocates…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>OT, but privacy advocates don't often get good news, so this seems worthy of note:</p>
<p>amnesty.org<br />
Campaigners win vital battle against UK mass surveillance<br />
13 September 2018, 11:04 UTC</p>
<p>&gt; The European Court of Human Rights has today ruled that UK laws enabling mass surveillance violate the rights to privacy and freedom of expression.<br />
&gt;...<br />
&gt; This case brought together three separate challenges from the following groups and individuals:<br />
&gt;<br />
&gt;    The American Civil Liberties Union (ACLU), Amnesty International, Bytes for All, the Canadian Civil Liberties Association, the Egyptian Initiative for Personal Rights, the Hungarian Civil Liberties Union, the Irish Council for Civil Liberties, the Legal Resources Centre (South Africa), Liberty and Privacy International.<br />
&gt;    Big Brother Watch, Open Rights Group, English PEN and Dr Constanze Kurz<br />
&gt;   The Bureau of Investigative Journalism and Alice Ross</p>
<p><a href="https://www.theguardian.com/uk-news/2018/sep/13/gchq-data-collection-violated-human-rights-strasbourg-court-rules" rel="nofollow">https://www.theguardian.com/uk-news/2018/sep/13/gchq-data-collection-vi…</a></p>
<p>twitter.com/Snowden<br />
Edward Snowden<br />
13 Sep 2018</p>
<p>&gt; For five long years, governments have denied that global mass surveillance violates of your rights. And for five long years, we have chased them through the doors of every court. Today, we won. Don't thank me: thank all of those who never stopped fighting.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-277273"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-277273" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">September 13, 2018</p>
    </div>
    <a href="#comment-277273">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-277273" class="permalink" rel="bookmark">thx 4 changelog</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>thx 4 changelog</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-277293"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-277293" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">September 14, 2018</p>
    </div>
    <a href="#comment-277293">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-277293" class="permalink" rel="bookmark">Not getting it to work for…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Not getting it to work for any video like youtube</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-277311"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-277311" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">September 14, 2018</p>
    </div>
    <a href="#comment-277311">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-277311" class="permalink" rel="bookmark">Looks like Twitter has…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Looks like Twitter has joined the collective and is blocking Tor users:</p>
<p>"We've detected that JavaScript is disabled in your browser. Would you like to proceed to legacy Twitter?" Which leads you to a broken page with just some make believe error number.</p>
<p>So stupid. Is there any way to bypass without enabling JS? Because I refuse to do that.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-277342"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-277342" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">September 15, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-277311" class="permalink" rel="bookmark">Looks like Twitter has…</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-277342">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-277342" class="permalink" rel="bookmark">Install Proxychains my…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Install Proxychains my friend &amp; use a SOCKS5 proxy. This solves problem for many bot herders ;) Good luck</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-277351"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-277351" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">September 16, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-277311" class="permalink" rel="bookmark">Looks like Twitter has…</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-277351">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-277351" class="permalink" rel="bookmark">There is no &quot;collective&quot; and…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>There is no "collective" and Twitter is not "blocking Tor users". Modern websites make extensive use of Javascript, and Twitter is one of them. You need to either go with the times or accept that disabling a website's core technology may cause it to break. No, there is no way to make people build their websites exclusively with technology used 15 years ago. The website wouldn't be very popular.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-277408"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-277408" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span content="Lord Haw Haw&#039;s elephantine dominatrix">Lord Haw Haw&#039;s… (not verified)</span> said:</p>
      <p class="date-time">September 20, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-277351" class="permalink" rel="bookmark">There is no &quot;collective&quot; and…</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-277408">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-277408" class="permalink" rel="bookmark">Twitter still works with the…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Twitter still works with the last pre-quantum + noscript. Tor browser version "7.5.6 (based on Mozilla Firefox 52.9.0) (32-bit)"<br />
Twitter html is a 'nightmare'. Look at view-source. </p>
<p>This blog.torproject.org comment form doesn't need js.</p>
<p>'Modern' sites with js are a regression. </p>
<p>Js and Swf are traditional exploit routes.</p>
<p>Some js sites require some fixing. Page Style &gt; No Style or a little css often fixes some common js stupidity. (Page Style &gt; No Style also temporarily fixes a lot of bad css.)<br />
nojs sites rarely need fixing. </p>
<p>A K6-2 PC running 2006 firefox (4mb download?) can instantaneously load those 'forgotten' late 1990s pages.</p>
<p>I've been on user-registration pages wherein a password conforming to the stated rules did not satisfy the 'instant' password rules-checking js. I concluded that the js was such a complex mess, that the site's writers couldn't get it to rule-check per their own stated standards.</p>
<p>To go to page 2 on one of Microsoft's help sites requires manually appending &amp;page=1 to the url, because the js-idiots can't figure out how to create a simple link.</p>
<p>As java wasn't necessary in web pages, js isn't necessary.<br />
The only pages that 'need' js are online editor pages (spreadsheets, image editors)<br />
Bookmarklets can be useful.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-277378"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-277378" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">September 17, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-277311" class="permalink" rel="bookmark">Looks like Twitter has…</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-277378">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-277378" class="permalink" rel="bookmark">&quot;Looks like Twitter has…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>"Looks like Twitter has joined the collective and is blocking Tor users:"</p>
<p>Yup it took them long enough lol</p>
<p>I wanna know how to use Twitter again via Tor without allowing javascript. There has to be a way.</p>
<p>Poor old Twitter's the latest following other giants like YouTube, which forced script requirements several months ago, leaving Tor users who care about OpSec in the dark!</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-277331"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-277331" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>anonymouse (not verified)</span> said:</p>
      <p class="date-time">September 15, 2018</p>
    </div>
    <a href="#comment-277331">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-277331" class="permalink" rel="bookmark">New brooms always sweeps…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>New brooms always sweeps clean. Or: New wine in old wineskins.<br />
Where I can see the IPs of the circuits in the new version? Is Transparency gone?<br />
Which kinda weed the developers smoke?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-277361"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-277361" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">September 16, 2018</p>
    </div>
    <a href="#comment-277361">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-277361" class="permalink" rel="bookmark">I can&#039;t see the tor circuit,…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I can't see the tor circuit, where can see it?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-277395"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-277395" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">September 19, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-277361" class="permalink" rel="bookmark">I can&#039;t see the tor circuit,…</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-277395">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-277395" class="permalink" rel="bookmark">You can see the circuit by…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>You can see the circuit by clicking the "show site information" icon.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-277362"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-277362" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">September 16, 2018</p>
    </div>
    <a href="#comment-277362">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-277362" class="permalink" rel="bookmark">Please for the love of all…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Please for the love of all that is good, stop merging those horrible Firefox updates. Just maintain a fork. Most vulnerabilities don't apply to NoScript and RequestPolicy users anyway.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-277368"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-277368" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>yijin (not verified)</span> said:</p>
      <p class="date-time">September 17, 2018</p>
    </div>
    <a href="#comment-277368">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-277368" class="permalink" rel="bookmark">good web</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>good <a href="https://www.adlist24.com/category/escorts" rel="nofollow">web</a></p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-277371"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-277371" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">September 17, 2018</p>
    </div>
    <a href="#comment-277371">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-277371" class="permalink" rel="bookmark">https://duckduckgo.com…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p><a href="https://duckduckgo.com" rel="nofollow">https://duckduckgo.com</a> responded with:<br />
We've detected that you have connected over Tor. There appears to be an issue with the Tor Exit Node you are currently using. Please recreate your Tor circuit or restart your Tor browser in order to fix this. If this error persists, please let us know: <a href="mailto:error-lite-tor@duckduckgo.com" rel="nofollow">error-lite-tor@duckduckgo.com</a></p>
<p>Exit node was 178.32.181.96, but subsequent requests were successful!<br />
WTF?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-277374"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-277374" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">September 17, 2018</p>
    </div>
    <a href="#comment-277374">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-277374" class="permalink" rel="bookmark">&quot;There is no &quot;collective&quot;…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>"There is no "collective" and Twitter is not "blocking Tor users". Modern websites make extensive use of Javascript, and Twitter is one of them. You need to either go with the times or accept that disabling a website's core technology may cause it to break. No, there is no way to make people build their websites exclusively with technology used 15 years ago. The website wouldn't be very popular."</p>
<p>Are you a bot? A lot of noise but nothing helpful. Maybe you could try again with a solution?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-277382"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-277382" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>hh (not verified)</span> said:</p>
      <p class="date-time">September 18, 2018</p>
    </div>
    <a href="#comment-277382">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-277382" class="permalink" rel="bookmark">thanks, your jobs are great!…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>thanks, your jobs are great! we chinese thank for your great job.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-278348"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-278348" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Windows XP Yes (not verified)</span> said:</p>
      <p class="date-time">November 01, 2018</p>
    </div>
    <a href="#comment-278348">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-278348" class="permalink" rel="bookmark">Nov 01 01:21:52 [notice] Tor…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Nov 01 01:21:52 [notice] Tor 0.3.3.10 (git-****) running on Windows XP with Libevent 2.0.22-stable, OpenSSL 1.0.2n, Zlib 1.2.11, Liblzma N/A, and Libzstd N/A.</p>
<p>Nov 01 01:22:01 [notice] Bootstrapped 100%: Done</p>
</div>
  </div>
</article>
<!-- Comment END -->
  </div>
  </article>

</main>
    <aside class="sidebar">
<!-- ##SIDEBAR## -->
</aside>
  </section>
  <footer><div class="row download">
    <div class="col circles"></div>
    <div class="col link">
        <h3>Download Tor Browser</h3>
        <p>Download Tor Browser to experience real private browsing without tracking, surveillance, or censorship.</p>
        <a class="btn" href="https://www.torproject.org/download/">Download Tor Browser <i class="fas fa-arrow-down-png-purple"></i></a>
    </div>
</div>
<div class="row social">
    <div class="col newsletter">
        <h3>Subscribe to our Newsletter</h3>
        <p>Get monthly updates and opportunities from the Tor Project:</p>
        <p class="w"><a class="btn btn-dark" role="button" href="https://newsletter.torproject.org/">Sign up</a></p>
    </div>
    <div class="col links">
        <div class="row">
            <h4><a target="_blank" href="https://www.facebook.com/TorProject/"><i class="fab fa-facebook"></i></a></h4>
            <h4><a target="_blank" href="https://mastodon.social/@torproject" rel="me"><i class="fab fa-mastodon"></i></a></h4>
            <h4><a target="_blank" href="https://twitter.com/torproject"><i class="fab fa-twitter"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://www.instagram.com/torproject"><i class="fab fa-instagram"></i></a></h4>
            <h4><a target="_blank" href="https://www.linkedin.com/company/tor-project"><i class="fab fa-linkedin"></i></a></h4>
            <h4><a target="_blank" href="https://github.com/torproject"><i class="fab fa-github"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://t.me/torproject"><i class="fab fa-telegram"></i></a></h4>
        </div>
    </div>
</div>
<div class="row notice">
    <p>Trademark, copyright notices, and rules for use by third parties can be found in our <a href="https://www.torproject.org/about/trademark/">FAQ</a>.</p>
</div></footer>
</body>
</html>
